//PreflightImages_201f.js
// 01.04.10 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Vrification des images importes

// activer l'affichage de dialogues (mesure prventive)
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester si un document est ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

//--------------------------------------------
// ***** prparer les variables  *****
//--------------------------------------------
// le document au premier plan
var curDoc = app.documents[0];
ctr = 0;

// mmoriser le nom du document
var docName = curDoc.name;

// prparer les listes
var minList  = new Array();
var maxList  = new Array();
var modiList = new Array();
var missList = new Array();
var rgbList  = new Array();

// appeler la fonction qui lit les rglages enregistrs
var checkDef = getPrefs();
// extraire les valeurs
if (checkDef != "") {
	var defVal = checkDef.split("\n");
	var minPPI = defVal[0]*1;
	var maxPPI = defVal[1]*1;
	var rck = defVal[2];
	if (rck == "true") { rck = true; } else { rck = false; }
	var mck = defVal[3];
	if (mck == "true") { mck = true; } else { mck = false; }
	var fck = defVal[4];
	if (fck == "true") { fck = true; } else { fck = false; }
}
else {
	var minPPI = 200;
	var maxPPI = 0;
	var rck = false;
	var mck = false;
	var fck = false;
}

// montrer le dialogue 
var checkDef = askUser();

// appeler la fonction qui crit le rsultat dans un fichier
writeResult(checkDef);

// appeler la fonction qui examine les images importes
checkImages();

// la fonction qui prpare les valeurs
function getPrefs() {
	var checkDef = "";
	// lire le fichier qui contient les valeurs mmorises
	var tempFolder = Folder.temp;
	var f = File(tempFolder + "/checkImg.txt");
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			checkDef = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return checkDef;
}

// demander l'utilisateur de faire son choix
function askUser() {
	// effacer des dialogues rests dans la mmoire
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	// prparer le dialogue
	var aDialog = app.dialogs.add({name:"Preflight images", canCancel:true});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Faire son choix"});
				staticTexts.add({staticLabel:" "});
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Rsolution minimale", minWidth:120});
							var minPPIval = integerEditboxes.add({editValue:minPPI, minimumValue:1, maximumValue:9999, minWidth:48});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Rsolution maximale", minWidth:120});
							var maxPPIval = integerEditboxes.add({editValue:maxPPI, minWidth:48});
						}
					}
				}
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:2});
				var getRGBbox = checkboxControls.add({staticLabel:"trouver les images en RVB", checkedState:rck});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:2});
				var getModbox = checkboxControls.add({staticLabel:"noter les images modifies", checkedState:mck});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:2});
				var getMssbox = checkboxControls.add({staticLabel:"noter les images manquantes", checkedState:fck});
			}
		}
		with (dialogColumns.add()) {
			staticTexts.add({staticLabel:"", minWidth:4});
		}
	}
	
	// afficher le dialogue
	if (aDialog.show() == true) {
		// la rsolution minimale
		minPPI = minPPIval.editValue;
		// la rsolution maximale
		maxPPI = maxPPIval.editValue;
		// trouver les images en RVB
		rck = getRGBbox.checkedState;
		// noter les images modifies
		mck = getModbox.checkedState;
		// noter les images manquantes
		fck = getMssbox.checkedState;
		// supprimer le dialogue de la mmoire
		aDialog.destroy();
		// prparer le rsultat pour l'enregistrer
		var checkDef = minPPI + "\n" + maxPPI + "\n" + rck + "\n" + mck + "\n" + fck;
	}
	else {
		aDialog.destroy();
		exit();
	}
	return checkDef;
}

// crire le rsultat dans un fichier
function writeResult(checkDef) {
	var tempFolder = Folder.temp;
	var f = File(tempFolder + "/checkImg.txt");
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(checkDef);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// la fonction principale
function checkImages() {
	// lister les chemins des images
	var allImages = curDoc.links;
	// une boucle  travers les images
	// en cas de problme, ajouter le nom de l'image  la liste correspondante
	for (var i=0; i<allImages.length; i++) {
		if (allImages[i].needed == true) {
			var curImg = allImages[i];
			// mmoriser l'tat de l'image
			imgStatus = curImg.status;
			if (imgStatus == 1819242340){ // = image modifie
				if (mck) {
					modiList.push(curImg.name);
					ctr++;
				}
			}
			else if (imgStatus == 1819109747) { // = image manquante
				if (fck) {
					missList.push(curImg.name);
					ctr++;
				}
			}
			else {
				if (imgStatus != 1282237028) { // = image incorpore
					if (minPPI > 0 || maxPPI > 0) {
						try {
							var imgPPI = curImg.parent.effectivePpi;
							if (minPPI > 0) {
								for (var p=0; p<2; p++) {
									if (imgPPI[p] < minPPI) {
										minList.push(curImg.name);
										ctr++;
										break;
									}
								}
							}
							if (maxPPI > 0) {
								for (var p=0; p<2; p++) {
									if (imgPPI[p] > maxPPI) {
										maxList.push(curImg.name);
										ctr++;
										break;
									}
								}
							}
						}
						catch (e) {
						}
					}
				}
				if (rck) {
					var colorSpace = curImg.parent.space;
					if (colorSpace == "RGB" || colorSpace == "RVB") {
						rgbList.push(curImg.name);
						ctr++;
					}
				}
			}
		}
	}
}

//---------------------------------------------
// ***** prparer les chanes de texte *****
//---------------------------------------------
var nMin = minList.length;
if (nMin > 0) {
	var minString = minList.join("\n");
}

var nMax = maxList.length;
if (nMax > 0) {
	var maxString = maxList.join("\n");
}

var nMods = modiList.length;
if (nMods > 0) {
	var modiString = modiList.join("\n");
}

var nMiss = missList.length;
if (nMiss > 0) {
	var missString = missList.join("\n");
}

var nRGB = rgbList.length;
if (nRGB > 0) {
	var rgbString = rgbList.join("\n");
}

//---------------------------------------------
// ***** tester la valeur du compteur *****
//---------------------------------------------
if (ctr>0) {
	// s'il n'y a qu'un seul problme, afficher un dialogue
	if (ctr == 1) {
		if (nMin == 1) {
			alert ("La rsolution effective de cette image est en dessous de "+ minPPI + " ppi:\n\n" + minString, "Achtung");
		}
		if (nMax == 1) {
			alert ("La rsolution effective de cette image est plus grande que "+ maxPPI + " ppi:\n\n" + maxString, "Achtung");
		}
		else if (nMods == 1) {
			alert ("Cette image est modifie:\n\n" + modiString, "Achtung");
		}
		else if (nMiss == 1) {
			alert ("Cette image est manquante:\n\n" + missString, "Achtung");
		}
		else if (nRGB == 1) {
			alert ("Cette image est en RVB:\n\n" + rgbString, "Achtung");
		}
	}
	// s'il y a plusieurs problmes, avertir, puis crer un document rapport
	else {
		alert ("Il y a des images  problmes.\n\nVoir le rapport.", "Attention");
		var repDoc = app.documents.add();
		if (repDoc.documentPreferences.pageWidth != 210) {
			repDoc.documentPreferences.pageWidth = 210;
		}
		if (repDoc.documentPreferences.pageHeight != 297) {
			repDoc.documentPreferences.pageHeight = 297;
		}
		repDoc.pages.item(0).marginPreferences.top = 15;
		repDoc.pages.item(0).marginPreferences.left = 25;
		repDoc.pages.item(0).marginPreferences.bottom = 15;
		repDoc.pages.item(0).marginPreferences.right = 15;
		var repFrame = repDoc.textFrames.add();
		repFrame.geometricBounds = [15,25,282,195];
		
		var repString = "Document \"" + docName + "\", les problmes:\r\r";
		
		if (nMin == 1) {
			repString = repString + "La rsolution effective de cette image est en dessous de "+ minPPI + " ppi:\n" + minString + "\r\r";
		}
		else if (nMin > 1) {
			repString = repString + "La rsolution effective de ces images est en dessous de "+ minPPI + " ppi:\n" + minString + "\r\r";
		}
		if (nMax == 1) {
			repString = repString + "La rsolution effective de cette image est plus grande que "+ maxPPI + " ppi:\n" + maxString + "\r\r";
		}
		else if (nMax > 1) {
			repString = repString + "La rsolution effective de ces images est plus grande que "+ maxPPI + " ppi:\n" + maxString + "\r\r";
		}
		if (nMods == 1) {
			repString = repString + "Cette image est modifie:\n" + modiString + "\r\r";
		}
		else if (nMods > 1) {
			repString = repString + "Ces images sont modifies:\n" + modiString + "\r\r";
		}
		if (nMiss == 1) {
			repString = repString + "Cette image est manquante:\n" + missString + "\r\r";
		}
		else if (nMiss > 1) {
			repString = repString + "Ces image sont manquantes:\n" + missString + "\r\r";
		}
		if (nRGB == 1) {
			repString = repString + "Cette image est en RVB:\n" + rgbString + "\r\r";
		}
		else if (nRGB > 1) {
			repString = repString + "Cette image sont en RVB:\n" + rgbString + "\r\r";
		}
		repFrame.contents = repString;
	}
}
else {
	alert ("Il n'y a pas d'images  problmes.", " ");
}